/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2014 Frederik Heber. All rights reserved.
 * 
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * PushAtomsAction.cpp
 *
 *  Created on: Dec 14, 2014
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include "CodePatterns/MemDebug.hpp"

#include "CodePatterns/Log.hpp"
#include "World.hpp"

#include "PushAtomsAction.hpp"

using namespace MoleCuilder;

// and construct the stuff
#include "PushAtomsAction.def"
#include "Action_impl_pre.hpp"
/** =========== define the function ====================== */
ActionState::ptr SelectionPushAtomsAction::performCall() {
  LOG(1, "Pushing atom selection.");
  World::getInstance().pushAtomSelection();

  return Action::success;
}

ActionState::ptr SelectionPushAtomsAction::performUndo(ActionState::ptr _state) {
  LOG(1, "Popping atom selection.");
  World::getInstance().popAtomSelection();

  return Action::success;
}

ActionState::ptr SelectionPushAtomsAction::performRedo(ActionState::ptr _state){
  return performCall();
}

bool SelectionPushAtomsAction::canUndo() {
  return true;
}

bool SelectionPushAtomsAction::shouldUndo() {
  return true;
}
/** =========== end of function ====================== */
